<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <!-- icon-top -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>

    <!-- table history -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <!-- <v-card class="block bg"> -->
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title>
                  <h1>
                    History
                  </h1>
                </v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_export = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-export-variant</v-icon>
                      Export To CSV</v-btn
                    >
                    <v-btn
                      @click="dialog_delete"
                      type="button"
                      color="error"
                      small
                      :disabled="disble_delete"
                      ><v-icon small class="pr-1">mdi-delete</v-icon> Delete
                      History</v-btn
                    >
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    v-model="selected"
                    :headers="headers"
                    :items="all_history"
                    :search="search"
                    :single-select="singleSelect"
                    show-select
                    :footer-props="{
                      'items-per-page-options': [10, 20, 50, 100]
                    }"
                    item-key="upload_retina_id"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="load_picture(item)"
                            color="teal"
                          >
                            mdi-download
                          </v-icon>
                        </template>
                        <span>Download</span>
                      </v-tooltip>

                      &nbsp;&nbsp;

                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="view_result(item)"
                            color="teal"
                          >
                            mdi-file-find
                          </v-icon>
                        </template>
                        <span>Zoom</span>
                      </v-tooltip>
                      &nbsp;&nbsp;
                    </template>

                    <!-- <template v-slot:item.result_diagnosis="{ item }">
                      <span
                        v-for="(items, i) in item.result_diagnosis"
                        :key="i"
                      >
                        {{ items.Retina }}
                      </span>
                    </template> -->
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table history -->

    <!-- dialog_export -->
    <v-dialog v-model="dialog_export" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Export To CSV
        </v-card-title>

        <v-form ref="form_export_data">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="5" md="5">
                  <v-menu
                    ref="menu"
                    v-model="menu"
                    :close-on-content-click="false"
                    :return-value.sync="form_export_data.start_date"
                    transition="scale-transition"
                    offset-y
                    min-width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="form_export_data.start_date"
                        label="Start Date"
                        prepend-icon="mdi-calendar-month-outline"
                        :rules="rule_date"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="form_export_data.start_date"
                      no-title
                      scrollable
                    >
                      <v-spacer></v-spacer>
                      <v-btn text color="primary" @click="menu = false"
                        >Cancel</v-btn
                      >
                      <v-btn
                        text
                        color="primary"
                        @click="$refs.menu.save(form_export_data.start_date)"
                        >OK</v-btn
                      >
                    </v-date-picker>
                  </v-menu>
                </v-col>

                <v-col cols="12" sm="2" md="2">
                  <!-- <span>TO</span> -->
                  <v-icon medium class="mt-5 ml-3">mdi-chevron-right</v-icon>
                </v-col>

                <v-col cols="12" sm="5" md="5">
                  <v-menu
                    ref="menu2"
                    v-model="menu2"
                    :close-on-content-click="false"
                    :return-value.sync="form_export_data.end_date"
                    transition="scale-transition"
                    offset-y
                    min-width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="form_export_data.end_date"
                        :rules="rule_date"
                        label="End Date"
                        prepend-icon="mdi-calendar-month-outline"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="form_export_data.end_date"
                      no-title
                      scrollable
                    >
                      <v-spacer></v-spacer>
                      <v-btn text color="primary" @click="menu2 = false"
                        >Cancel</v-btn
                      >
                      <v-btn
                        text
                        color="primary"
                        @click="$refs.menu2.save(form_export_data.end_date)"
                        >OK</v-btn
                      >
                    </v-date-picker>
                  </v-menu>
                </v-col>

                <!-- <v-col cols="12" sm="12" md="12">
                  <v-select
                    outlined
                    dense
                    label="Choose a result"
                    v-model="form_export_data.select_disease"
                    :rules="rule_result"
                    :items="list_result"
                    multiple
                  >
                  </v-select>
                </v-col> -->
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_export" style="color: white;"
            >Cancel</v-btn
          >
          <v-btn color="blue" @click="export_csv" style="color: white;"
            >Export</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_export -->

    <!-- dialog_zoom -->
    <v-dialog v-model="dialog_zoom" persistent scrollable max-width="1000px">
      <v-card>
        <v-card-title style="color:white;background:#428bca">
          Zoom Result
          <v-spacer></v-spacer>
          <v-btn icon dark @click="dialog_zoom = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-title>
        <v-divider></v-divider>

        <v-card-text>
          <v-row>
            <v-col cols="12" sm="6" md="6">
              <v-img :src="result_zoom.link_s3"></v-img>
            </v-col>

            <v-col cols="12" sm="6" md="6">
              <v-img :src="result_zoom.link_s3_plot"></v-img>
            </v-col>
          </v-row>

          <v-row>
            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                File Name : {{ result_zoom.old_filename }}
              </h3>
              <v-divider></v-divider>
            </v-col>

            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                Status :
                <span
                  v-for="(items, i) in result_zoom.result_diagnosis"
                  :key="i"
                >
                  {{ items.Retina }}
                  <br />
                </span>
              </h3>
              <v-divider></v-divider>
            </v-col>

            <v-col cols="12" class="text-start">
              <v-text-field
                dense
                label="Feedback"
                v-model="form_feedback.feed_back"
              ></v-text-field>
            </v-col>

            <v-btn class="ml-2" depressed color="primary" @click="feedback()">
              Submit
            </v-btn>
          </v-row>
        </v-card-text>
      </v-card>
    </v-dialog>
    <!-- dialog_zoom -->
  </v-app>
</template>

<script>
// import { v4 as uuidv4 } from "uuid";
import moment from "moment";
export default {
  name: "History",
  data() {
    return {
      api: "https://1ls.manageai.co.th",
      // api: "https://1ls-demo.manageai.co.th",
      // api: "http://localhost:8080",
      session_id: "",
      show: false,
      fab: false,
      dialog_zoom: false,
      result_zoom: "",
      dialog_feedback: false,
      // feedback: "",
      //date
      menu: false,
      modal: false,
      menu2: false,

      list_result: [
        "Normal",
        "Tuberculosis",
        "Pneumothorax",
        "Emphysema",
        "Abnormal",
        "Pneumonia"
      ],
      form_export_data: {
        start_date: new Date().toISOString().substr(0, 10),
        end_date: new Date().toISOString().substr(0, 10),
        // select_disease: [],
        hospital_id: this.$cookies.get("info_login").hospital_id
      },
      form_feedback: {
        feed_back: "",
        upload_id: ""
      },
      // rule
      rule_date: [v => !!v || "Please choose date"],
      // rule_result: [
      //   v => !!v || "Please choose a result",
      //   v => v.length != 0 || "Please choose a result"
      // ],
      //
      dialog_export: false,
      singleSelect: false,
      selected: [],
      dialog_loader: false,
      disble_delete: true,
      all_history: [],
      search: "",
      headers: [
        {
          text: "Date/Time Upload",
          align: "start",
          value: "upload_datetime",
          sortable: false,
          width: "17%"
        },
        // {
        //   text: "Date/Time X-Ray",
        //   align: "start",
        //   value: "xray_date",
        //   sortable: false,
        //   width: "12.5%"
        // },
        // {
        //   text: "Patient Name",
        //   align: "start",
        //   value: "patient_name",
        //   sortable: false,
        //   width: "18.5%"
        // },
        {
          text: "File Name",
          align: "start",
          value: "old_filename",
          sortable: false
        },
        {
          text: "Result",
          align: "start",
          value: "result_diagnosis[0].Retina",
          width: "16%"
        },
        { text: "Action", value: "actions", sortable: false }
      ]
    };
  },
  mounted() {
    this.$cookies.get("info_login");
    console.log(this.$cookies.get("info_login").hospital_id);
    this.session_id = this.$cookies.get("info_login").session_id;
    this.get_history();
  },

  methods: {
    moment,

    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_history() {
      this.dialog_loader = true;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/history_retina", {
          params: {
            hospital_id: this.$cookies.get("info_login").hospital_id,
            user_id: this.$cookies.get("info_login").user_id
          },
          headers: {
            Authorization: this.$cookies.get("info_login").session_id //the token is a variable which holds the token
          }
        })
        .then(response => {
          console.log("for=>", response.data.data);
          if (response.data.status == "fail") {
            this.$swal({
              icon: "error",
              title: "Error!",
              text: response.data.message,
              confirmButtonText: "OK",
              allowOutsideClick: false
            }).then(() => {
              window.location.href = this.api;
            });
          } else {
            console.log("history=>", response);
            for (let index = 0; index < response.data.data.length; index++) {
              response.data.data[index].upload_datetime = moment(
                response.data.data[index].upload_datetime
              ).format("YYYY-MM-DD HH:mm:ss");
            }
          }
          this.all_history = response.data.data;
          this.dialog_loader = false;
        })
        .catch(error => {
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        });
    },

    dialog_delete() {
      const upload_id_array = [];
      console.log("selected", this.selected);
      for (let index = 0; index < this.selected.length; index++) {
        upload_id_array.push(this.selected[index].upload_retina_id);
        console.log("upload_id_array", upload_id_array);
      }
      // this.dialog_delete = true;
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete history!",
        icon: "warning",
        showCancelButton: true,
        allowOutsideClick: false,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes"
      }).then(result => {
        if (result.value) {
          this.dialog_loader = true;
          this.axios
            .delete(
              process.env.VUE_APP_API +
                "/api/v3/history_retina?upload_retina_id=" +
                upload_id_array +
                "&user_id=" +
                this.$cookies.get("info_login").user_id,
              {
                headers: {
                  Authorization: this.$cookies.get("info_login").session_id
                }
              }
            )
            .then(response => {
              this.dialog_loader = false;
              console.log(response.data);
              console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: response.data.message,
                  confirmButtonText: "OK",
                  allowOutsideClick: false
                }).then(() => {
                  window.location.href = this.api;
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete history success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false
                }).then(() => {
                  this.get_history();
                });
              }
            })
            .catch(error => {
              console.log("error", error);
            });
        }
      });
    },

    cancel_export() {
      this.dialog_export = false;
    },

    export_csv() {
      if (!this.$refs.form_export_data.validate()) return;
      this.form_export_data["hospital_id"] = this.$cookies.get(
        "info_login"
      ).hospital_id;
      console.log("form_export", this.form_export_data);
      this.form_export_data["user_id"] = this.$cookies.get(
        "info_login"
      ).user_id;
      this.dialog_export = false;
      this.dialog_loader = true;
      //api export csv
      this.axios
        .post(
          process.env.VUE_APP_API + "/api/v3/export_csvretina",
          this.form_export_data,
          {
            responseType: "arraybuffer",
            headers: {
              Authorization: this.session_id
            }
          }
        )
        .then(response => {
          this.dialog_loader = false;
          console.log("response", response);
          if (response.data.status == "fail") {
            this.$swal({
              icon: "error",
              title: "Error!",
              text: response.data.message,
              confirmButtonText: "OK",
              allowOutsideClick: false
            }).then(() => {
              window.location.href = this.api;
            });
          } else {
            let blob = new Blob([response.data], {
              type: "application/vnd.ms-excel"
            });
            let link = document.createElement("a");
            link.href = window.URL.createObjectURL(blob);
            var filename = `report_${moment().format()}.csv`;
            link.download = filename;
            document.body.appendChild(link);
            this.$swal({
              icon: "success",
              title: "Success!",
              text: "Export To CSV success.",
              confirmButtonText: "OK",
              allowOutsideClick: false
            })
              .then(() => {
                link.click();
                this.form_export_data = {
                  start_date: new Date().toISOString().substr(0, 10),
                  end_date: new Date().toISOString().substr(0, 10),
                  // select_disease: [],
                  hospital_id: this.$cookies.get("info_login").hospital_id
                };

                // console.log("response", response.data.api);
                // console.log("response", response.data.path_filename);
                // let res_api = response.data.api;
                // console.log("res_api", res_api);
                // //api export agian
                // this.axios
                //   .get(
                //     res_api +
                //       "?path_filename=" +
                //       response.data.path_filename +
                //       "&uuid?=" +
                //       uuidv4(),
                //     {
                //       responseType: "arraybuffer"
                //     }
                //   )
                //   .then(response => {
                //     console.log("response", response);
                //     let blob = new Blob([response.data], {
                //       type: "application/vnd.ms-excel"
                //     });
                //     let link = document.createElement("a");
                //     link.href = window.URL.createObjectURL(blob);
                //     var filename = `report_${moment().format()}.csv`;
                //     link.download = filename;
                //     document.body.appendChild(link);
                //     this.$swal({
                //       icon: "success",
                //       title: "Success!",
                //       text: "Export To CSV success.",
                //       confirmButtonText: "OK",
                //       allowOutsideClick: false
                //     }).then(() => {
                //       link.click();
                //       this.form_export_data = {
                //         start_date: new Date().toISOString().substr(0, 10),
                //         end_date: new Date().toISOString().substr(0, 10),
                //         // select_disease: [],
                //         hospital_id: this.$cookies.get("info_login").hospital_id
                //       };
                //     });
              })
              .catch(error => {
                console.log("error", error);
              });
          }
        })
        .catch(error => {
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        });
    },

    load_picture(item) {
      console.log(item);
      if (item.link_s3_plot == null) {
        window.open(item.link_s3);
      } else {
        window.open(item.link_s3_plot);
      }
    },

    view_result(item) {
      console.log("result", item);
      this.result_zoom = item;
      this.form_feedback.feed_back = this.result_zoom["feed_back"];
      // for (
      //   let index = 0;
      //   index < this.result_zoom.list_status_disease.length;
      //   index++
      // ) {
      //   console.log(this.result_zoom.list_status_disease[index]);
      // }
      // console.log("link_s3_plot", item.link_s3);
      // console.log("link_s3_png", item.link_s3_plot);
      this.dialog_zoom = true;
    },

    feedback() {
      if (
        this.form_feedback.feed_back == null ||
        this.form_feedback.feed_back == "" ||
        this.form_feedback.feed_back == this.result_zoom.feed_back
      )
        return;
      console.log("form_feedback", this.form_feedback);
      console.log(this.result_zoom);
      this.form_feedback[
        "upload_retina_id"
      ] = this.result_zoom.upload_retina_id;
      this.form_feedback["user_id"] = this.$cookies.get("info_login").user_id;
      this.result_zoom["feed_back"] = this.form_feedback.feed_back;
      console.log("check=>", this.form_feedback);
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/upload_retina",
          this.form_feedback
        )
        .then(response => {
          console.log(response);
          this.$swal({
            icon: "success",
            title: "<span style='font-family:Kanit;sans-serif'>Success!</span>",
            html:
              "<span style='font-family:Kanit;sans-serif'>Feedback success.</span>",
            className: "swal-title",
            confirmButtonText:
              "<span style='font-family:Kanit;sans-serif'>OK</span>",
            allowOutsideClick: false
          });
          // this.$refs.form_feedback.reset();
          // this.dialog_feedback = false;
        })
        .catch(error => {
          console.log("error", error);
        });
    }
  },
  watch: {
    selected(val) {
      console.log(val);
      if (val.length == 0) {
        this.disble_delete = true;
      } else {
        this.disble_delete = false;
      }
    }
  }
};
</script>

<style>
/* swal-title {
  margin: 0px !important;
  font-size: 25px !important;
  box-shadow: 0px 1px 1px rgba(0, 0, 0, 0.21) !important;
  margin-bottom: 28px !important;
} */
</style>
